#version 130
precision mediump float;

uniform mat4 cameraTransform;
uniform mat4 worldTransform;
uniform mat4 normalTransform;

uniform vec3 cameraLocation;
uniform vec3 previousCameraLocation;



uniform vec3 mainLightLocation;
uniform vec4 mainLightColor;
//uniform float mainLigthRadius;

in vec4 vertex;
in vec3 normal;
in vec2 texcoord;

out vec2 texture_coordinates; 
out vec3 transNormal;
out vec3 viewDirection;
out vec3 lightDirection;

// Motion Blur Vars
vec4 currentPosition;
vec4 previousPosition;
float deltaTime = 60;
uniform mat4 previousCameraTransform;
out vec2 velocity;



void main(){
	
	vec4 objPos = worldTransform * vertex ;
	
	// transform normal vector
	vec4 normal4 = vec4(normal, 0.0f);
	transNormal = ( normalTransform * normal4 ).xyz ;
	
	viewDirection  = cameraLocation - objPos.xyz;
	lightDirection = mainLightLocation - objPos.xyz;
	
	// Get texture coordinates and feed them to the fragment shader
	texture_coordinates = texcoord; 
	
	
	
	// Motion Blur Code
//	previousPosition = (-previousCameraTransform) * objPos;
	currentPosition = cameraTransform * objPos;
//	velocity = -currentPosition.xy - previousPosition.xy ;
	
	//velocity = (cameraLocation.xz - previousCameraLocation.xz) * 100;
	
	
	velocity = vec2((cameraLocation.x - previousCameraLocation.x)*100, 0.03);
	
	
	
	
	
	
	// transform vertex
	gl_Position = currentPosition;

	
}